<template>
    <q-page class="bg-base">
        <Container :max-height="1">
            <DocumentWrapper ref="wrap" class="relative-position">
                <ListPage :desktop="5" v-if="alerts == null">
                    <q-list separator class="q-gutter-sm q-pa-md">
                        <AlertItemSkeleton v-for="i in 3" :key="i"/>
                    </q-list>
                </ListPage>
                <div v-else-if="Alerts.length === 0">
                    <AnimationComponent text="There are no alerts!"
                                        :animation="$animations.emptyBox"
                                        :max-height="1"/>
                </div>
                <ListPage :desktop="5" v-else>
                    <q-infinite-scroll @load="LoadMore" :offset="250">
                        <q-list class="q-gutter-sm q-pa-md">
                            <AlertItem v-for="a in Alerts" :key="a.id" :alert="a"/>
                        </q-list>
                        <template v-slot:loading>
                            <div class="row justify-center q-my-md">
                                <q-spinner-dots color="primary" size="40px" v-if="load < alerts.length"/>
                            </div>
                        </template>
                    </q-infinite-scroll>
                </ListPage>
            </DocumentWrapper>
        </Container>
    </q-page>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import Container from "components/Core/Container.vue";
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import AnimationComponent from "components/Core/AnimationComponent.vue";
import AlertItem from "components/Entities/List/AlertItem.vue";
import ListPage from "components/Core/ListPage.vue";
import {AlertPrincipalResponse} from "src/classLibrary/APIModels/analytics/alertPrincipalResponse";
import AlertItemSkeleton from "components/Entities/List/AlertItemSkeleton.vue";
import {$$} from "src/classLibrary/Utility";

@Component({
    components: {AlertItemSkeleton, ListPage, AlertItem, AnimationComponent, DocumentWrapper, Container}
})
export default class SubContractorAlerts extends Vue {
    alerts: AlertPrincipalResponse[] | null = null;


    get Alerts() {
        return this.alerts?.Take(this.load)
    }

    load = 15;

    routeParams = {
        subId: '',
    }

    async LoadMore(_: any, done: Function) {
        await $$(300)
        this.load += 15;
        if (this.load < (this.alerts?.length || 100)) {
            done();
        }
    }

    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    async loadAlerts() {
        const t = await this.$auth.AnalyticsToken;
        const pid = this.PersistentStore.StoreValue.project;
        const r = await this.$analyticsApi.Get<AlertPrincipalResponse[]>(`Alert/${pid}/subcontractor/${this.routeParams.subId}`, null, t);
        if (r.isErr()) {
            return this.Wrap.SubmitError(r.unwrapErr())
        }
        this.alerts = r.unwrap();

    }

    async init() {
        await this.loadAlerts();
    }
}
</script>
